public inbox for glibc-cvs@sourceware.org
help / color / mirror / Atom feed
* [glibc] elf: Add ld.so test with non-existing program name
@ 2024-04-08 17:19 Florian Weimer
  0 siblings, 0 replies; only message in thread
From: Florian Weimer @ 2024-04-08 17:19 UTC (permalink / raw)
  To: glibc-cvs

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=ae7468a7b0bcf22e9cd5fcae42bb9e4f65de83ee

commit ae7468a7b0bcf22e9cd5fcae42bb9e4f65de83ee
Author: Florian Weimer <fweimer@redhat.com>
Date:   Mon Apr 8 19:19:09 2024 +0200

    elf: Add ld.so test with non-existing program name
    
    None of the existing tests seem to cover the case where
    _dl_signal_error is called without an active error handler.
    The new elf/tst-rtld-does-not-exist test triggers such a
    _dl_signal_error call from _dl_map_object.
    
    Reviewed-by: H.J. Lu <hjl.tools@gmail.com>

Diff:
---
 elf/Makefile                   |  7 +++++++
 elf/tst-rtld-does-not-exist.sh | 39 +++++++++++++++++++++++++++++++++++++++
 2 files changed, 46 insertions(+)

diff --git a/elf/Makefile b/elf/Makefile
index 4f1903391a..6dad11bcfb 100644
--- a/elf/Makefile
+++ b/elf/Makefile
@@ -621,6 +621,13 @@ $(objpfx)tst-valgrind-smoke.out: tst-valgrind-smoke.sh $(objpfx)ld.so $(objpfx)v
 		'$(run-program-env)' '$(rpath-link)' $(objpfx)valgrind-test \
 		'$(valgrind-suppressions-tst-valgrind-smoke)' > $@; $(evaluate-test)
 
+ifeq ($(run-built-tests),yes)
+tests-special += $(objpfx)tst-rtld-does-not-exist.out
+endif
+$(objpfx)tst-rtld-does-not-exist.out: tst-rtld-does-not-exist.sh $(objpfx)ld.so
+	$(SHELL) $< $(objpfx)ld.so > $@; \
+	$(evaluate-test)
+
 tests += $(tests-execstack-$(have-z-execstack))
 ifeq ($(run-built-tests),yes)
 tests-special += \
diff --git a/elf/tst-rtld-does-not-exist.sh b/elf/tst-rtld-does-not-exist.sh
new file mode 100644
index 0000000000..a4a781ccfd
--- /dev/null
+++ b/elf/tst-rtld-does-not-exist.sh
@@ -0,0 +1,39 @@
+#!/bin/sh
+# Check that running ld.so with a non-existing file prints an error.
+# Copyright (C) 2024 Free Software Foundation, Inc.
+# This file is part of the GNU C Library.
+
+# The GNU C Library is free software; you can redistribute it and/or
+# modify it under the terms of the GNU Lesser General Public
+# License as published by the Free Software Foundation; either
+# version 2.1 of the License, or (at your option) any later version.
+
+# The GNU C Library is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+# Lesser General Public License for more details.
+
+# You should have received a copy of the GNU Lesser General Public
+# License along with the GNU C Library; if not, see
+# <https://www.gnu.org/licenses/>.
+
+export LC_ALL=C
+
+rtld="$1"
+tmp_out="$(mktemp)"
+
+$rtld program-does-not-exist 2>"$tmp_out"
+status=$?
+echo "$rtld exit status: $status"
+echo "output (with expected error):"
+cat "$tmp_out"
+
+if test $status -eq 127 \
+	&& grep -q "^program-does-not-exist: error while loading shared libraries: program-does-not-exist: cannot open shared object file$" "$tmp_out" \
+	&& test "$(wc -l < "$tmp_out")" -eq 1 ; then
+    status=0
+else
+    status=1
+fi
+rm "$tmp_out"
+exit $status

^ permalink raw reply	[flat|nested] only message in thread

only message in thread, other threads:[~2024-04-08 17:19 UTC | newest]

Thread overview: (only message) (download: mbox.gz / follow: Atom feed)
-- links below jump to the message on this page --
2024-04-08 17:19 [glibc] elf: Add ld.so test with non-existing program name Florian Weimer

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).